Package org.apache.sysds.runtime.matrix.data

# Class DnnParameters

java.lang.Object
org.apache.sysds.runtime.matrix.data.DnnParameters

All Implemented Interfaces:
  `Serializable`

public class DnnParameters extends Object implements Serializable
This class is container that stores parameters required for executing following operations: conv2d, conv2d_backward_data, conv2d_backward_filter, maxpooling, maxpooling_backward, lstm, lstm_backward

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`MatrixBlock`
`bias`
`int`
`C`
`int`
`D`
`boolean`
`enableNative`
`int[]`
`end_indexes_h`
`int[]`
`end_indexes_w`
`int`
`H`
`MatrixBlock`
`input1`
`MatrixBlock`
`input2`
`MatrixBlock`
`input3`
`MatrixBlock`
`input4`
`MatrixBlock`
`input5`
`MatrixBlock`
`input6`
`MatrixBlock`
`input7`
`MatrixBlock`
`input8`
`MatrixBlock`
`input9`
`int`
`K`
`int`
`M`
`double`
`minValForMaxPoolOperations`
`int`
`N`
`int`
`numThreads`
`MatrixBlock`
`output`
`MatrixBlock`
`output2`
`MatrixBlock`
`output3`
`MatrixBlock`
`output4`
`MatrixBlock`
`output5`
`int`
`P`
`int`
`pad_h`
`int`
`pad_w`
`int`
`Q`
`int`
`R`
`boolean`
`return_sequences`
`int`
`S`
`int[]`
`start_indexes_h`
`int[]`
`start_indexes_w`
`int`
`stride_h`
`int`
`stride_w`
`int`
`T`
`int`
`W`

## Constructor Summary

Constructors
Constructor
Description
`DnnParameters(int N, int C, int H, int W, int K, int R, int S, int stride_h, int stride_w, int pad_h, int pad_w, int numThreads)`
`DnnParameters(int N, int D, int T, int M, MatrixBlock x, MatrixBlock w, MatrixBlock bias, MatrixBlock out0, MatrixBlock c0, boolean return_sequences, int numThreads)`
`DnnParameters(int n, int d, int t, int m, MatrixBlock x, MatrixBlock w, MatrixBlock bias, MatrixBlock out0, MatrixBlock c0, MatrixBlock cache_out, MatrixBlock cache_c, MatrixBlock cache_ifog, boolean return_sequences, MatrixBlock dout, MatrixBlock dc, MatrixBlock dx, MatrixBlock dw, MatrixBlock db, MatrixBlock dout0, MatrixBlock dc0, int numThreads)`
`DnnParameters(long N, long C, long H, long W, long K, long R, long S, long stride_h, long stride_w, long pad_h, long pad_w, int numThreads)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`compare(DnnParameters that)`
`boolean`
`isAllOnes(Integer... params)`
`boolean`
`isOutputThreadSafe()`
`boolean`
`isStride1Pad0()`
`void`
`setIfUnknown(Hop N, Hop C, Hop H, Hop W, Hop K, Hop R, Hop S, Hop stride_h, Hop stride_w, Hop pad_h, Hop pad_w, int numThreads)`
`String`
`toString()`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### N

public int N

### C

public int C

### H

public int H

### W

public int W

### K

public int K

### R

public int R

### S

public int S

### P

public int P

### Q

public int Q

### D

public int D

### T

public int T

### M

public int M

### stride_h

public int stride_h

### stride_w

public int stride_w

### pad_h

public int pad_h

### pad_w

public int pad_w

### numThreads

public int numThreads

### enableNative

public boolean enableNative

### return_sequences

public boolean return_sequences

### input1

public MatrixBlock input1

### input2

public MatrixBlock input2

### output

public MatrixBlock output

### input3

public MatrixBlock input3

### input4

public MatrixBlock input4

### input5

public MatrixBlock input5

### input6

public MatrixBlock input6

### input7

public MatrixBlock input7

### input8

public MatrixBlock input8

### input9

public MatrixBlock input9

### output2

public MatrixBlock output2

### output3

public MatrixBlock output3

### output4

public MatrixBlock output4

### output5

public MatrixBlock output5

### bias

public MatrixBlock bias

### start_indexes_h

public int[] start_indexes_h

### end_indexes_h

public int[] end_indexes_h

### start_indexes_w

public int[] start_indexes_w

### end_indexes_w

public int[] end_indexes_w

### minValForMaxPoolOperations

public double minValForMaxPoolOperations

## Constructor Details

### DnnParameters

public DnnParameters(long N, long C, long H, long W, long K, long R, long S, long stride_h, long stride_w, long pad_h, long pad_w, int numThreads)

### DnnParameters

public DnnParameters(int N, int C, int H, int W, int K, int R, int S, int stride_h, int stride_w, int pad_h, int pad_w, int numThreads)

### DnnParameters

public DnnParameters(int N, int D, int T, int M, MatrixBlock x, MatrixBlock w, MatrixBlock bias, MatrixBlock out0, MatrixBlock c0, boolean return_sequences, int numThreads)

### DnnParameters

public DnnParameters(int n, int d, int t, int m, MatrixBlock x, MatrixBlock w, MatrixBlock bias, MatrixBlock out0, MatrixBlock c0, MatrixBlock cache_out, MatrixBlock cache_c, MatrixBlock cache_ifog, boolean return_sequences, MatrixBlock dout, MatrixBlock dc, MatrixBlock dx, MatrixBlock dw, MatrixBlock db, MatrixBlock dout0, MatrixBlock dc0, int numThreads)

## Method Details

### compare

public boolean compare(DnnParameters that)

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### setIfUnknown

public void setIfUnknown(Hop N, Hop C, Hop H, Hop W, Hop K, Hop R, Hop S, Hop stride_h, Hop stride_w, Hop pad_h, Hop pad_w, int numThreads)

### isOutputThreadSafe

public boolean isOutputThreadSafe()

### isStride1Pad0

public boolean isStride1Pad0()

### isAllOnes

public boolean isAllOnes(Integer... params)